<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright © 2002 - 2013 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Name: Live Last Seen Users Panel
| Filename: live_last_seen_users_panel.php
| Author: PHP-Fusion Mods UK
| Version: v1.00
| Developers: Craig
| Site: http://www.phpfusionmods.co.uk
+--------------------------------------------------------+
| Refresh Code by skpacman http://www.php-fusion.us/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
 if (!defined("IN_FUSION")) { die("Access Denied"); }
 
 if (file_exists(THEME."locale/".$settings['locale'].".php")) {
   include THEME."locale/".$settings['locale'].".php";
     } else {
   include THEME."locale/Greek.php"; 
}
global $userdata;

add_to_head("<style type='text/css'>
		.lstsn { margin:0; float:left; margin-left:-10px ; z-index:	999;}
		.col { padding: 10px 2px 2px 2px; width:100%; }
		.col img {margin: 5px; }
		.lstsn-user { opacity:0.5; filter:alpha(opacity=80); /* For IE8 and earlier */ }
		.lstsn-user:hover { opacity:1.0; filter:alpha(opacity=100); /* For IE8 and earlier */ }
		.lstsn-users-online { border: 2px solid #00C1FF; width: 38px; height: 38px; border-radius: 50%;}
		.lstsn-users-five { border: 1px solid #FFA70F; width: 38px; height: 38px; border-radius: 50%;}
		.lstsn-users-offline { border: 1px solid #FF3D3D; width: 38px; height: 38px; border-radius: 50%; }
	.lstsn-user:hover  {
-webkit-transform: rotate(720deg);
transform: rotate(720deg);
}
.lstsn-user {

-webkit-transition: all 0.7s ease;
transition: all 0.7s ease;
}

	
	</style>");

add_to_head("<script type='text/javascript'>
			function AJAX(){
			try{
			xmlHttp=new XMLHttpRequest(); // Firefox, Opera 8.0+, Safari
			return xmlHttp;
			}
			catch (e){
			try{
			xmlHttp=new ActiveXObject('Msxml2.XMLHTTP'); // Internet Explorer
			return xmlHttp;
			}
			catch (e){
			try{
			xmlHttp=new ActiveXObject('Microsoft.XMLHTTP');
			return xmlHttp;
			}
			catch (e){
			alert('Your browser does not support AJAX.');
			return false;
			}
			}
			}
			}

			// Timestamp for preventing IE caching the GET request (common function)

			function fetch_unix_timestamp()
			{
			 return parseInt(new Date().getTime().toString().substring(0, 10))
			}

			function refreshdiv_livelastseenusers(){

			var seconds = 5;
			var divid = 'livelastseenusers';
			var url = src='".THEME."includes/live_last_seen_users_load.php';
			var xmlHttp_one = AJAX();
			var timestamp = fetch_unix_timestamp();
			var nocacheurl = url+'?t='+timestamp;

			xmlHttp_one.onreadystatechange=function(){
			if(xmlHttp_one.readyState==4){
			document.getElementById(divid).innerHTML=xmlHttp_one.responseText;
			setTimeout('refreshdiv_livelastseenusers()',seconds*1000);
			}
			}
			xmlHttp_one.open('GET',nocacheurl,true);
			xmlHttp_one.send(null);
			}
			var seconds;
			window.onload = function startrefresh(){
			setTimeout('refreshdiv_livelastseenusers()',seconds*1000);
			}
</script>");

	
		echo "<script type='text/javascript'>refreshdiv_livelastseenusers();</script><div id='livelastseenusers'></div>";

?>
