<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2013 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: theme.php
| Author: JoiNNN
| Author: Dimi
| Web: www.hellasplus.com
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------+
| This file is part of the PHP-Fusion Theme standard.
+--------------------------------------------------------+
| Theme: Ddraig
| PHP-Fusion version: 7.02.xx
| Theme version: v2 by Dimi
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

//Theme settings
require_once THEME."theme_settings.php";
define("THEME_BULLET", "<img src='".THEME."images/arrow_right_2.png' class='bullet' alt='>' />");
require_once THEME."includes/functions.inc.php";
require_once INCLUDES."theme_functions_include.php";
require_once THEME."includes/functions.php";
function get_head_tags(){
	//Theme width class
	echo "<style type='text/css'>.theme-width {max-width: ".THEME_MAXWIDTH.";min-width: ".THEME_MINWIDTH."}</style>\n";
}

if (function_exists("add_handler")) {
	add_handler("theme_output"); 
}

function render_page($license=false) {
global $aidlink, $locale, $settings, $main_style, $setting, $userdata, $mysql_queries_time;

//Check for locale
if (file_exists(THEME."locale/".$settings['locale'].".php")) {
	include THEME."locale/".$settings['locale'].".php";
} else {
	include THEME."locale/English.php";
}

//Open Sans font and mobile width

 add_to_head("<!-- Mobile Specific Metas -->
<meta name='viewport' content='width=device-width, initial-scale=1.0' />
<script type='text/javascript' src='".THEME."js/menu_to_top.js' /></script>
<script src='".THEME."js/html5.js'></script>
<script src='".THEME."js/css3-mediaqueries.js'></script> 
<link href='http://fonts.googleapis.com/css?family=Open+Sans:400,600,700' rel='stylesheet' type='text/css' />
<link rel='stylesheet'href='http://maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css'/>");
//End

echo "<div id='header'><div class='theme-width clearfix center'>
<div class='sub-date'>".showsubdate()."</div>";

//Social top / login top pop up

//require_once THEME."includes/login.php";
require_once THEME."includes/social_top.php";
//require_once THEME."includes/nav_top.php";
echo "</div>";
echo "</div>";

//Style (2)
if (STYLE2 == 1) {
echo "<div class='theme-width clearfix center'>";
add_to_head("<link type='text/css' href='".THEME."css/style2.css' rel='stylesheet' media='screen' />"); }
echo "</div>";

//Banners Logo
echo "<div id='mainheader'>
<div class='theme-width clearfix center'>";
echo "<div id='logo'>".showbanners()."</div>";
echo "</div>";


//Sub header
echo "<div id='subheader'><div class='theme-width clearfix center'>";
//Navigation links
require_once THEME."includes/nav.php";
require_once THEME."includes/search.php";
echo "</div>";
echo "</div>";
echo "</div>";


echo "<div id='main' class='".$main_style." theme-width center clearfix'>";

//Panels structure
echo (LEFT ? "<div id='side-border-left' class='sides flleft'>\n".LEFT."</div>\n" : "");
echo (RIGHT ? "<div id='side-border-right' class='sides flright'>\n".RIGHT."</div>\n" : "");

//Main structure
echo "<div id='main-bg'><div id='container'>";
echo (U_CENTER ? "<div class='upper-block'>".U_CENTER."</div>" : "");
echo "<div class='main-block'>".CONTENT."</div>";
echo (L_CENTER ? "<div class='lower-block'>".L_CENTER."</div>" : "");
echo "</div></div>\n";
echo "</div>\n";

if (FOOT_FOOT == 1) {
//Footer
echo "<div id='footer'>";
echo "<div class='footer theme-width center'>";
require_once THEME."includes/footerb.php";
echo "</div></div>";

}

	echo "<a href='#0' class='cd-top' title='".$locale['to_top']."'></a>\n";	
	//Subfooter	
	echo "<div id='subfooter'>			
	<div class='subfooter center theme-width'>";
	echo "<div id='copyright'><div class='flleft'><strong>Powered by <a href='http://www.php-fusion.co.uk'".$link_class.">PHP-Fusion</a> copyright &copy; 2002 - ".date("Y")." by Nick Jones. Released as free software without warranties under
<a href='http://www.gnu.org/licenses/agpl-3.0.html'".$link_class.">GNU Affero GPL</a> v3.</a><a href='http://www.hellasplus.com'> [ Designed by Dimi ] </a></strong></div>";
	echo "<div class='flright text-right'>".stripslashes($settings['footer'])."</div>";
	echo "<div class='subfooter clearfix'>";
echo "<div class='flleft' style='width: 50%'>";
		if ($settings['rendertime_enabled'] == 1 || ($settings['rendertime_enabled'] == 2 && iADMIN)) {echo showrendertime();}{ echo showcounter(); }
echo "</div>\n";
echo "</div></div>\n";

//Show warning if Theme Control Panel is not infused and if user has access to Infusions
	if (!SETTINGS_INSTALLED && checkrights("I")) {
		//Render the warning
		if (!isset($_COOKIE[COOKIE_PREFIX.'tcpnotice'])) {
			replace_in_output("<!--error_handler-->", "<!--error_handler-->".$locale['tcp_warning']);
		}
		//Message close script
		add_to_footer("<script type='text/javascript'>
		$('#tcp-warn').click( function(e) {
			e.preventDefault();

			$.get(this.href);
			$('.tcp-warn').fadeTo('slow',0.01,function(){
				$(this).slideUp('slow',function(){
					$(this).hide()
				});
			});
		});
		</script>");
	}

add_to_footer("<script type='text/javascript' src='".THEME."js/main.js'></script>");
	add_to_footer("<script type='text/javascript'>/*<![CDATA[*/
	//Header search - area script
	$('#search_area').click( function() {
		$(this).fadeTo('slow',0,function(){
			$(this).animate({'width': '0', 'padding': '0'}, 300, function(){
				$(this).remove()
			});
		});
	$('#search_type').attr({'disabled': 'disabled'}) //disabling(instead of removing) keeps input field value after page reload
	});
	$('#search_type').removeAttr('disabled') //if is disabled, stays disabled after page reload. Remove attribute on page load

	//Header search - placeholder script
	var text = $('#splaceholder').text();
	if ($('#sinput').attr('value') != '') {
		$('#splaceholder').text('') //remove placeholder text if other value is kept after page reload
	}
	//Remove placeholder text when typing
	$('#sinput').bind('input propertychange', function() {
		if ($(this).attr('value') != '') {
			$('#splaceholder').text('') //remove
		} else {
			$('#splaceholder').text(text) //add it back if no text input
		}
	});"
	//Thread preview script
	.((THREAD_PREV == 1 && INFORUM && in_array(FUSION_SELF, array("index.php", "viewforum.php"))) ? "
	//Thread preview
	$('a.preview-link').click(function (e) {
		e.preventDefault();
		var el		= $(this),
			parts	= this.href.split('='),
			trgt	= parts[1],
			thistr	= el.parent().parent();
			thid	= $('#thid' + trgt),
			preview = '".$locale['prev_thread']."',
			close_preview = '".$locale['close_prev']."';

		//Closing the preview
		if (thid.hasClass('expanded')) {
			thid.children('div').stop(true, true).slideToggle('fast');
			thid.removeClass('expanded');
			thistr.removeClass('previewing');
			el.toggleClass('icon-list icon-cancel expand close').attr('title', preview);
		//Expanding the preview after was loaded
		} else if (thid.hasClass('loaded') && !thid.hasClass('expanded')) {
			thid.children('div').stop(true, true).slideToggle('fast');
			thid.addClass('expanded');
			thistr.addClass('previewing');
			el.toggleClass('icon-list icon-cancel expand close').attr('title', close_preview);
		//Loading and expanding the preview
		} else if(!el.hasClass('loading')) {
			el.toggleClass('icon-list icon-arrows-cw animate-spin expand loading');
			$.ajax({url:'".THEME."includes/thread_preview.inc.php?thread_id=' + trgt,
				success: function(result){
					thistr.after('<tr><td id=\'thid' + trgt + '\' class=\'preview expanded loaded\' colspan=\'4\'>' + result + '<\/td><\/tr>');
					thistr.addClass('previewing');
					el.toggleClass('icon-arrows-cw animate-spin icon-cancel close loading').attr('title', close_preview);
					$('#thid' + trgt).children('div').stop(true, true).slideToggle('fast');
  				},
				error: function () {
					el.toggleClass('icon-arrows-cw animate-spin icon-list expand loading');
				}
			});
		}
	});" : "")."
	/*]]>*/
	</script>");

	add_to_footer("<script type='text/javascript' src='".THEME."js/flexmenu.js'></script>
	<script type='text/javascript'>
	$('.navigation').flexMenu({'activeClass' : '.current-link'});
	$('.findex').flexMenu({'hideAll' : true, 'activeClass' : '.none', 'hideOnMouseOut' : false});
	</script>");
	//Relative time script
	if (REL_TIME == 1) {
		add_to_footer("<script type='text/javascript' src='".THEME."js/relative-date.js'></script>");
		add_to_footer("<script type='text/javascript'>/*<![CDATA[*/
		var timenow = '".(iMEMBER ? showdate("longdate", time()) : strftime($settings['longdate'], (time())+($settings['serveroffset']*3600)))."';
		$('".REL_TIME_EL."').toRelativeTime(".(($settings['locale'] != "English" && file_exists(THEME."locale/".$settings['locale'].".php")) ? "{
		'seconds': '".$locale['seconds']."',
		'minute': '".$locale['minute']."',
		'minutes': '".$locale['minutes']."',
		'today': '".$locale['today']."',
		'yesterday': '".$locale['yesterday']."',
		'thisWeek': '".$locale['thisWeek']."',
		'other': '".$locale['other']."',
		'monthNames': ".$locale['monthNames'].",
		'monthNamesShort': ".$locale['monthNamesShort'].",
		'dayNames': ".$locale['dayNames'].",
		'dayNamesShort': ".$locale['dayNamesShort']."
		}" : "").");
		/*]]>*/
		</script>");
	}
}


//Render News
function render_news($subject, $news, $info) {
global $locale, $settings, $aidlink; $res = "";
	// Title as link to extended news
	$subject = preg_replace("/<a name='news_([0-9]+)' id='news_([0-9]+)'><\/a>/i", '', $subject);
	if (!isset($_GET['readmore'])) {
		$subject = "<a href='".BASEDIR."news.php?readmore=".$info['news_id']."'>".$subject."</a>";
	}
	// Breaking news
	$breaking_news_time = 156600; //Breaking News Time (1 Hour/60 Mins/3600 Seconds)
	if (time()-$info['news_date'] < $breaking_news_time) {
		$subject = "<span class='breaking-news tag big red'>".$locale['breaking_news']."</span> ".$subject;
	}
	// Sticky news
	if ($info['news_sticky'] == 1) {
		$subject = "<i class='sticky-news icon-pin' title='".$locale['sticky']."'></i> ".$subject;}
opentable($subject, "post");
	echo "<ul class='item-info news-info clearfix'>\n";
	//Author
	echo "<li class='author'>".profile_link($info['user_id'], $info['user_name'], $info['user_status'])."</li>\n";
	//Date
	echo "<li class='dated'>".showdate("newsdate", $info['news_date'])."</li>\n";
	//Category
	echo "<li class='cat'>\n";
		if ($info['cat_id']) {
			echo "<a href='".BASEDIR."news_cats.php?cat_id=".$info['cat_id']."'>".$info['cat_name']."</a>\n";
		} else {
			echo "<a href='".BASEDIR."news_cats.php?cat_id=0'>".$locale['global_080']."</a>";
		}
	
echo "</li>\n";


	//Reads
	if ($info['news_ext'] == "y" || ($info['news_allow_comments'] && $settings['comments_enabled'] == "1")) {
	echo "<li class='reads'>\n";
		echo $info['news_reads'].$locale['global_074']; 
	echo "</li>\n";}
	//Comments
	if ($info['news_allow_comments'] && $settings['comments_enabled'] == "1") { echo "<li class='comments'><a ".(isset($_GET['readmore']) ? "class='scroll'" : "")." href='".BASEDIR."news.php?readmore=".$info['news_id']."#comments'>".$info['news_comments']."".($info['news_comments'] == 1 ? $locale['global_073b'] : $locale['global_073'])."</a></li>\n"; }
	
              echo "<div class='flright clearfix'>\n
	           <span class='print'><a href='print.php?type=N&amp;item_id=".$info['news_id']."'><img src='".get_image("printer")."' alt='".$locale['global_075']."' title='".$locale['global_075']."' width='20' height='16' style='border:0;' /></a></span>\n";
	         if (iADMIN && checkrights("N")) {
          echo " <a href='".ADMIN."news.php".$aidlink."&amp;action=edit&amp;news_id=".$info['news_id']."'><img src='".get_image("edit")."' alt='".$locale['global_076']."' title='".$locale['global_076']."' border='0' /></a>\n";
	            }
	
echo "</ul>\n";
	//The message
echo "<div class='floatfix'>".($info['cat_image'].$news)."</div>\n";
echo "<!--news_id-".$info['news_id']."_end-->";
	closetable();
}

//Render Articles
function render_article($subject, $article, $info, $item_type, $item_id) {
global $locale, $settings, $aidlink; $res = "";
	opentable($subject, "article");
	echo "<ul class='item-info article-info'>\n";
	//Author
	echo "<li class='author'>".profile_link($info['user_id'], $info['user_name'], $info['user_status'])."</li>\n";
	//Date
	echo "<li class='dated'>".showdate("newsdate", $info['article_date'])."</li>\n";
	//Category
	echo "<li class='cat'>\n";
		if ($info['cat_id']) {
			echo "<a href='".BASEDIR."articles.php?cat_id=".$info['cat_id']."'>".$info['cat_name']."</a>";
		} else {
			echo "<a href='".BASEDIR."articles.php?cat_id=0'>".$locale['global_080']."</a>";
		}
	echo "</li>\n";
	//Reads
	echo "<li class='reads'>".$info['article_reads'].$locale['global_074']."</li>\n";
	//Comments
	if ($info['article_allow_comments'] && $settings['comments_enabled'] == "1") { echo "<li class='comments'><a class='scroll' href='".BASEDIR."articles.php?article_id=".$info['article_id']."#comments'>".$info['article_comments'].($info['article_comments'] == 1 ? $locale['global_073b'] : $locale['global_073'])."</a></li>\n"; }


              echo "<div class='flright clearfix'>\n
	               <span class='print'><a href='print.php?type=A&amp;item_id=".$info['article_id']."'><img src='".get_image("printer")."' alt='".$locale['global_075']."' title='".$locale['global_075']."' width='20' height='16' style='border:0;' /></a></span>\n";
	            if (iADMIN && checkrights("A")) {
	           echo "<a href='".ADMIN."articles.php".$aidlink."&amp;action=edit&amp;article_id=".$info['article_id']."'><img src='".get_image("edit")."' alt='".$locale['global_076']."' title='".$locale['global_076']."' border='0' /></a>\n";
             	}




	echo "</ul>\n";
	//The message
	echo ($info['article_breaks'] == "y" ? nl2br($article) : $article)."\n";
	echo "<!--article_id-".$info['article_id']."_end-->";
	closetable();
}
//Render comments
function render_comments($c_data, $c_info){
global $locale, $settings;
	if ($c_info['admin_link'] !== FALSE) {
		echo "<div class='comment-admin floatfix'>".$c_info['admin_link']."</div>\n";
	}
	if (!empty($c_data)){
		echo "<div class='user-comments floatfix'>\n";
		$c_makepagenav = '';
		if ($c_info['c_makepagenav'] !== FALSE) { 
			echo $c_makepagenav = "<div style='text-align:center;margin-bottom:5px;'>".$c_info['c_makepagenav']."</div>\n"; 
		}
		foreach($c_data as $data) {
			echo "<div id='c".$data['comment_id']."' class='comment'>\n";
			//User avatar
			if ($settings['comments_avatar'] == "1") { echo "<span class='user_avatar'>".$data['user_avatar']."</span>\n"; $noav = ""; } else { $noav = "noavatar"; }
			echo "<div class='tbl1 comment-wrap $noav'>";
			//Pointer tip
			if ($settings['comments_avatar'] == "1") { echo "<div class='pointer'><span>&lt;</span></div>\n"; }
			//Options
			echo "<div class='comment-info'>";
			if ($data['edit_dell'] !== FALSE) { 
				echo "<div class='actions flright'>".$data['edit_dell']."\n</div>\n";
			}
			//Info
			echo "<a class='scroll' href='".FUSION_REQUEST."#c".$data['comment_id']."'>#".$data['i']."</a> |\n";
			echo "<span class='comment-name'>".$data['comment_name']."</span>\n";
			echo "<span class='small'>".$data['comment_datestamp']."</span></div>\n";
			//The message
			echo "<div class='comment-msg'>".$data['comment_message']."</div></div></div>\n";
		}
		echo $c_makepagenav;
		echo "</div>\n";
	} else {
		echo "<div class='nocomments-message spacer'>".$locale['c101']."</div>\n";
	} 
}


//Content Panels

function opentable($title, $custom_class="", $info="", $type="") {
global $p_data;
	//News and Articles IDs, and Options(Edit/Print)
	$id = "";
	$options = "";
	if ($type == "N") {
		$id = "id='news-".$info['news_id']."'";
		$options = itemoptions2("N", $info['news_id'], $info);
	} elseif ($type == "A") {
		$id = "id='article-".$info['article_id']."'";
		$options = itemoptions2("A", $info['article_id'], $info);
	}

	//Wrapp panel in div with class based on panel name
	$class = $p_data['panel_filename'];
	if ($class == "" && $custom_class == "") {
		//Panel with no custom class and no panel name file
		$class = "panel";
	} elseif ($class == "" && $custom_class != "") {
		//Panel with custom class and no panel name file
		$class = $custom_class." panel";
	} else {
		//Panel with panel name file
		$class = str_replace("_panel", " panel", $class);
	}

	echo "<div ".$id." class='".$class."'>";
		
	echo "<h1 class='maincap clearfix'>";
	echo "<span class='title'>".$title."</span>";
	if ($info != "") {
		echo "<span class='options'>";
		echo $options;
		echo "</span>";
	}
	echo "</h1>\n";
	echo "<div class='contentbody clearfix'>";
}

function closetable() {
	echo "</div></div>\n";
}

//Side panels
function openside($title, $collapse = false, $state = "on") {
global $panel_collapse, $p_data; $panel_collapse = $collapse;
	//Wrap panel in div with class based on panel name
	$class = $p_data['panel_filename'];
	if ($class == "") {	$class = "panel"; } else { $class = str_replace("_panel", " panel", $class); }

	echo "<div class='".$class."'>";
	echo "<h2 class='panelcap'>";
	echo "<span class='title'>".$title."</span>\n";
	if ($collapse == true) {
		$boxname = str_replace(" ", "", $title);
	
	}
	echo "</h2>";
	echo "<div class='panelbody clearfix'>\n";
	if ($collapse == true) { echo panelstate($state, $boxname); }
}

function closeside() {
global $panel_collapse;
	echo "</div>\n";
	echo "</div>\n";
	if ($panel_collapse == true) { echo "</div>\n"; }
}

?>